
/****** Object:  StoredProcedure [dbo].[SP_INVOICE_CREATION_MAIN_VERIFICATION]    Script Date: 30/04/2021 17:02:58 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

-- =============================================
-- Author:		FID.Ridwan
-- Create date: 2020-12-12
-- Description:	
-- 
-- =============================================
ALTER PROCEDURE [dbo].[SP_INVOICE_CREATION_MAIN_VERIFICATION] @USER_ID VARCHAR(20) = 'agan'
	,@RI_V_PROCESSID BIGINT
	,@RI_V_SUPP_CD VARCHAR(10)
	,@RESULT VARCHAR(1) OUTPUT
AS
BEGIN
	SET NOCOUNT ON;

	DECLARE @IsError CHAR(1) = 'N'
		,@RESULT_2 VARCHAR(1)
	DECLARE @FUNCTION_ID AS VARCHAR(MAX) = '51002'
		,@MODULE_ID AS VARCHAR(MAX) = '5'
		,@FUNTION_NM AS VARCHAR(MAX) = 'SP Invoice Creation Main Verification'
		,@MSG_TXT AS VARCHAR(MAX)
		,@MSG_TYPE AS VARCHAR(MAX)
		,@LOG_LOCATION AS VARCHAR(MAX) = 'SP_INVOICE_CREATION_MAIN_VERIFICATION'
		,@L_ERR AS INT = 0
		,@N_ERR AS INT = 0
		,@PARAM1 AS VARCHAR(MAX)
		,@PARAM2 AS VARCHAR(MAX)
		,@PARAM3 AS VARCHAR(MAX)
		,@query VARCHAR(MAX)
		,@ICSSrvrName NVARCHAR(256)
		,@ICSDBName NVARCHAR(256)
		,@L_V_STATUS_SUPP VARCHAR(10) = 'N'

	BEGIN TRY
		-- DELETE STAGING
		DELETE
		FROM TB_S_INVOICE_UPLOAD
		WHERE SUPP_CD = @RI_V_SUPP_CD

		IF OBJECT_ID('tempdb..#TEMP_INV_UPLOAD_VALIDASI') IS NOT NULL
		BEGIN
			DROP TABLE #TEMP_INV_UPLOAD_VALIDASI
		END

		CREATE TABLE #TEMP_INV_UPLOAD_VALIDASI (
			ROW_NO_PAR INT
			,PROCESS_ID BIGINT
			,SUPP_CD VARCHAR(6)
			,PO_NO VARCHAR(10)
			,PO_ITEM_NO VARCHAR(5)
			,ORI_MAT_NO VARCHAR(23)
			,MAT_NO VARCHAR(23)
			,PROD_PURPOSE_CD VARCHAR(5)
			,SOURCE_TYPE_CD VARCHAR(1)
			,PACKING_TYPE VARCHAR(1)
			,PART_COLOR_SFX VARCHAR(2)
			,MAT_TEXT VARCHAR(40)
			,MAT_DOC_NO VARCHAR(10)
			,MAT_DOC_ITEM VARCHAR(4)
			,COMP_PRICE_CD VARCHAR(4)
			,SUPP_MANIFEST VARCHAR(16)
			,DOC_DT DATE
			,QUANTITY NUMERIC(13, 3)
			,ORDER_NO VARCHAR(16)
			,DOCK_CD VARCHAR(20)
			,SUPP_INV_NO VARCHAR(12)
			,S_QUANTITY NUMERIC(13, 3)
			,PRICE_AMT NUMERIC(16, 5)
			,PAYMENT_CURR VARCHAR(3)
			,AMMOUNT NUMERIC(16, 5)
			,VALIDATION_TYPE VARCHAR(1)
			,REMARKS VARCHAR(2000)
			,ROW_NO INT
			,IS_PROCESS INT
			,LOC VARCHAR(100)
			,REGION VARCHAR(15)
			,N_AMMOUNT NUMERIC(16, 5)
			,N_EX_RATE NUMERIC(7, 2)
			,N_AMMOUNT_CUR NUMERIC(16, 5)
			,V_COND_CATEGORY VARCHAR(10)
			,V_TAX_CD VARCHAR(10)
			,PRIMARY KEY (
				PROCESS_ID
				,ROW_NO
				)
			)

		CREATE NONCLUSTERED INDEX [IDX_TEMP_INV_UPLOAD_VALIDASI] ON #TEMP_INV_UPLOAD_VALIDASI (
			MAT_DOC_NO ASC
			,MAT_DOC_ITEM ASC
			,COMP_PRICE_CD ASC
			,SUPP_MANIFEST ASC
			)
			WITH (
					PAD_INDEX = OFF
					,STATISTICS_NORECOMPUTE = OFF
					,SORT_IN_TEMPDB = OFF
					,DROP_EXISTING = OFF
					,ONLINE = OFF
					,ALLOW_ROW_LOCKS = ON
					,ALLOW_PAGE_LOCKS = ON
					) ON [PRIMARY]

		IF OBJECT_ID('tempdb..#TEMP_R_GRIR_BY_DOC_NO') IS NOT NULL
		BEGIN
			DROP TABLE #TEMP_R_GRIR_BY_DOC_NO
		END

		CREATE TABLE #TEMP_R_GRIR_BY_DOC_NO (
			MAT_DOC_NO VARCHAR(10)
			,ITEM_NO INT
			,COMP_PRICE_CD VARCHAR(4)
			,CONDITION_CATEGORY VARCHAR(1)
			,TAX_CD VARCHAR(6)
			,MOVEMENT_QTY NUMERIC(13, 3)
			,PO_DETAIL_PRICE NUMERIC(16, 5)
			,SUPPLIER_CD VARCHAR(6)
			,ICS_MAT_NO VARCHAR(23)
			,CANCEL_FLAG VARCHAR(1)
			,INV_WO_GR_FLAG VARCHAR(1)
			,INV_REF_NO VARCHAR(16)
			,INV_NO VARCHAR(10)
			,INV_ITEM_NO VARCHAR(5)
			)

		IF OBJECT_ID('tempdb..#TEMP_R_GRIR_BY_MAT_NO_ICS') IS NOT NULL
		BEGIN
			DROP TABLE #TEMP_R_GRIR_BY_MAT_NO_ICS
		END

		CREATE TABLE #TEMP_R_GRIR_BY_MAT_NO_ICS (
			MAT_DOC_NO VARCHAR(10)
			,ITEM_NO INT
			,COMP_PRICE_CD VARCHAR(4)
			,CONDITION_CATEGORY VARCHAR(1)
			,TAX_CD VARCHAR(6)
			,MOVEMENT_QTY NUMERIC(13, 3)
			,PO_DETAIL_PRICE NUMERIC(16, 5)
			,SUPPLIER_CD VARCHAR(6)
			,ICS_MAT_NO VARCHAR(23)
			,CANCEL_FLAG VARCHAR(1)
			,INV_WO_GR_FLAG VARCHAR(1)
			,INV_REF_NO VARCHAR(16)
			,INV_NO VARCHAR(10)
			,INV_ITEM_NO VARCHAR(5)
			,PART_COLOR_SFX VARCHAR(2)
			,PACKING_TYPE VARCHAR(1)
			)

		-- * get list inv upload * --
		INSERT INTO #TEMP_INV_UPLOAD_VALIDASI
		SELECT ROW_NUMBER() OVER (
				ORDER BY (
						SELECT 1
						)
				) NO
			,PROCESS_ID
			,SUPP_CD
			,PO_NO
			,PO_ITEM_NO
			,MAT_NO_REF ORI_MAT_NO
			,MAT_NO
			,PROD_PURPOSE_CD
			,SOURCE_TYPE_CD SOURCE_TYPE
			,PACKING_TYPE
			,PART_COLOR_SFX
			,MAT_TEXT
			,MAT_DOC_NO
			,MAT_DOC_ITEM
			,COMP_PRICE_CD
			,INV_REF_NO SUPP_MANIFEST
			,DOC_DT
			,QTY QUANTITY
			,ORDER_NO
			,DOCK_CD
			,SUPP_INV_NO
			,S_QTY S_QUANTITY
			,PRICE_AMT
			,PAY_CURR PAYMENT_CURR
			,AMT AMMOUNT
			,VALIDATION_TYPE
			,REMARKS
			,ROW_NO
			,0
			,''
			,''
			,0
			,0
			,0
			,''
			,''
		FROM TB_T_INV_UPLOAD T WITH (NOLOCK)
		WHERE T.SUPP_CD = @RI_V_SUPP_CD
			AND T.PROCESS_ID = @RI_V_PROCESSID
		ORDER BY T.SUPP_INV_NO
			,T.MAT_NO
			,T.MAT_DOC_ITEM;

		INSERT INTO #TEMP_R_GRIR_BY_DOC_NO
		SELECT DISTINCT R.MAT_DOC_NO
			,R.ITEM_NO
			,R.COMP_PRICE_CD
			,R.CONDITION_CATEGORY
			,R.TAX_CD
			,R.MOVEMENT_QTY
			,R.PO_DETAIL_PRICE
			,R.SUPPLIER_CD
			,R.ICS_MAT_NO
			,R.CANCEL_FLAG
			,R.INV_WO_GR_FLAG
			,R.INV_REF_NO
			,R.INV_NO
			,R.INV_ITEM_NO
		FROM TB_R_GR_IR R WITH (NOLOCK)
		JOIN #TEMP_INV_UPLOAD_VALIDASI T ON R.MAT_DOC_NO = T.MAT_DOC_NO
			AND R.ITEM_NO = T.MAT_DOC_ITEM
			AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
		WHERE T.PROCESS_ID = @RI_V_PROCESSID
			AND T.SUPP_CD = @RI_V_SUPP_CD;

		INSERT INTO #TEMP_R_GRIR_BY_MAT_NO_ICS
		SELECT DISTINCT R.MAT_DOC_NO
			,R.ITEM_NO
			,R.COMP_PRICE_CD
			,R.CONDITION_CATEGORY
			,R.TAX_CD
			,R.MOVEMENT_QTY
			,R.PO_DETAIL_PRICE
			,R.SUPPLIER_CD
			,R.ICS_MAT_NO
			,R.CANCEL_FLAG
			,R.INV_WO_GR_FLAG
			,R.INV_REF_NO
			,R.INV_NO
			,R.INV_ITEM_NO
			,R.PART_COLOR_SFX
			,R.PACKING_TYPE
		FROM TB_R_GR_IR R WITH (NOLOCK)
		JOIN #TEMP_INV_UPLOAD_VALIDASI T ON R.INV_REF_NO = T.SUPP_MANIFEST
			AND R.ICS_MAT_NO = T.MAT_NO
			AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
		WHERE T.PROCESS_ID = @RI_V_PROCESSID
			AND T.SUPP_CD = @RI_V_SUPP_CD;

		-- when remarks is not blank
		UPDATE T
		SET T.IS_PROCESS = 1
			,T.REGION = 'REMARK'
		FROM #TEMP_INV_UPLOAD_VALIDASI T
		WHERE ISNULL(T.REMARKS, '') <> ''

		/* ---- Star Check GR/IR ---- */
		/* 2.1 when material document are not blanks */
		IF EXISTS (
				SELECT TOP 1 1
				FROM #TEMP_INV_UPLOAD_VALIDASI T
				WHERE PROCESS_ID = @RI_V_PROCESSID
					AND T.SUPP_CD = @RI_V_SUPP_CD
					AND ISNULL(T.MAT_DOC_NO, '') <> ''
					AND ISNULL(T.MAT_DOC_ITEM, '') <> ''
					AND IS_PROCESS = 0
				)
		BEGIN
			UPDATE T
			SET T.REGION = 'DOC_NO'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			WHERE PROCESS_ID = @RI_V_PROCESSID
				AND T.SUPP_CD = @RI_V_SUPP_CD
				AND ISNULL(T.MAT_DOC_NO, '') <> ''
				AND ISNULL(T.MAT_DOC_ITEM, '') <> ''
				AND IS_PROCESS = 0

			-- GR Data blank 
			UPDATE T
			SET T.REMARKS = 'No Data Found for ' + T.SUPP_MANIFEST + ', ' + T.MAT_NO + ', ' + T.PART_COLOR_SFX + ', ' + T.PACKING_TYPE + ' and ' + T.COMP_PRICE_CD
				,T.IS_PROCESS = 1
				,T.VALIDATION_TYPE = 'E'
				,T.LOC = 'No data found in GR/IR'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			LEFT JOIN #TEMP_R_GRIR_BY_DOC_NO R ON T.MAT_DOC_NO = R.MAT_DOC_NO
				AND T.MAT_DOC_ITEM = R.ITEM_NO
				AND T.COMP_PRICE_CD = R.COMP_PRICE_CD
				AND ISNULL(CANCEL_FLAG, '0') = '0'
				AND COALESCE(INV_WO_GR_FLAG, 'N') = 'N'
			WHERE PROCESS_ID = @RI_V_PROCESSID
				AND T.SUPP_CD = @RI_V_SUPP_CD
				AND T.REGION = 'DOC_NO'
				AND T.IS_PROCESS = 0
				AND R.MAT_DOC_NO IS NULL

			-- GR IR more than one row
			UPDATE T
			SET T.REMARKS = 'The Number Specified In Exact Fetch Is Less Than The Rows Returned.'
				,T.IS_PROCESS = 1
				,T.VALIDATION_TYPE = 'E'
				,T.LOC = 'GR/IR more than one'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			JOIN (
				SELECT R.MAT_DOC_NO
					,R.ITEM_NO
					,R.COMP_PRICE_CD
				FROM #TEMP_INV_UPLOAD_VALIDASI T
				JOIN #TEMP_R_GRIR_BY_DOC_NO R ON T.MAT_DOC_NO = R.MAT_DOC_NO
					AND T.MAT_DOC_ITEM = R.ITEM_NO
					AND T.COMP_PRICE_CD = R.COMP_PRICE_CD
					AND ISNULL(CANCEL_FLAG, '0') = '0'
					AND COALESCE(INV_WO_GR_FLAG, 'N') = 'N'
				WHERE T.IS_PROCESS = 0
					AND T.REGION = 'DOC_NO'
				GROUP BY R.MAT_DOC_NO
					,R.ITEM_NO
					,R.COMP_PRICE_CD
				HAVING COUNT(1) > 1
				) TT ON T.MAT_DOC_NO = TT.MAT_DOC_NO
				AND T.MAT_DOC_ITEM = TT.ITEM_NO
				AND T.COMP_PRICE_CD = TT.COMP_PRICE_CD
			WHERE T.IS_PROCESS = 0
				AND T.REGION = 'DOC_NO'

			/* call function invoice verification */
			EXEC SP_INVOICE_CREATION_VERIFICATION @USER_ID
				,@RI_V_PROCESSID
				,@RI_V_SUPP_CD
				,'DOC_NO'
				,@RESULT_2 OUTPUT;
				/* end function invoice verification */
		END -- END material document are not blanks

		/* 2.2 when material document or item material document are blanks */
		IF EXISTS (
				SELECT TOP 1 1
				FROM #TEMP_INV_UPLOAD_VALIDASI T
				WHERE 1 = 1
					AND ISNULL(T.MAT_DOC_NO, '') = ''
					AND ISNULL(T.MAT_DOC_ITEM, '') = ''
					AND IS_PROCESS = 0
				)
		BEGIN -- material document are blanks
			-- 2.2.A check based on ICS
			UPDATE T
			SET T.REGION = 'ICS_MAT_NO'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			WHERE ISNULL(T.MAT_DOC_NO, '') = ''
				AND ISNULL(T.MAT_DOC_ITEM, '') = ''
				AND IS_PROCESS = 0

			-- GR IR more than one row
			UPDATE T
			SET T.REMARKS = 'The Number Specified In Exact Fetch Is Less Than The Rows Returned.'
				,T.IS_PROCESS = 1
				,T.VALIDATION_TYPE = 'E'
				,T.LOC = 'GR/IR more than one'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			JOIN (
				SELECT R.INV_REF_NO
					,R.ICS_MAT_NO
					,R.COMP_PRICE_CD
					,T.ROW_NO
				FROM #TEMP_INV_UPLOAD_VALIDASI T
				JOIN #TEMP_R_GRIR_BY_MAT_NO_ICS R ON R.INV_REF_NO = T.SUPP_MANIFEST
					AND R.ICS_MAT_NO = T.MAT_NO
					AND R.PART_COLOR_SFX = T.PART_COLOR_SFX
					AND R.PACKING_TYPE = T.PACKING_TYPE
					AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
					AND ISNULL(R.CANCEL_FLAG, '0') = '0'
					AND COALESCE(INV_WO_GR_FLAG, 'N') = 'Y'
				WHERE T.IS_PROCESS = 0
					AND T.REGION = 'ICS_MAT_NO'
				GROUP BY R.MAT_DOC_NO
					,R.ITEM_NO
					,R.COMP_PRICE_CD
				HAVING COUNT(1) > 1
				) TT ON T.SUPP_MANIFEST = TT.INV_REF_NO
				AND T.MAT_NO = TT.ICS_MAT_NO
				AND T.COMP_PRICE_CD = TT.COMP_PRICE_CD
				AND T.ROW_NO = TT.ROW_NO
			WHERE T.IS_PROCESS = 0
				AND T.REGION = 'ICS_MAT_NO'

			UPDATE T
			SET T.REMARKS = 'A_EXIST'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			JOIN #TEMP_R_GRIR_BY_MAT_NO_ICS R ON R.INV_REF_NO = T.SUPP_MANIFEST
				AND R.ICS_MAT_NO = T.MAT_NO
				AND R.PART_COLOR_SFX = T.PART_COLOR_SFX
				AND R.PACKING_TYPE = T.PACKING_TYPE
				AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
				AND ISNULL(R.CANCEL_FLAG, '0') = '0'
				AND COALESCE(INV_WO_GR_FLAG, 'N') = 'Y'
			WHERE T.REGION = 'ICS_MAT_NO'
				AND T.IS_PROCESS = 0

			-- @L_N_COUNT_GR_B > 1
			UPDATE T
			SET T.REMARKS = 'Incorrect (Suffix Color is not valid)'
				,T.IS_PROCESS = 1
				,T.VALIDATION_TYPE = 'E'
				,T.LOC = 'Check Remark'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			JOIN (
				SELECT R.INV_REF_NO
					,R.ICS_MAT_NO
					,R.COMP_PRICE_CD
					,T.ROW_NO
				FROM #TEMP_INV_UPLOAD_VALIDASI T
				JOIN #TEMP_R_GRIR_BY_MAT_NO_ICS R ON R.INV_REF_NO = T.SUPP_MANIFEST
					AND R.ICS_MAT_NO = T.MAT_NO
					AND R.PART_COLOR_SFX = T.PART_COLOR_SFX
					AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
					AND ISNULL(R.CANCEL_FLAG, '0') = '0'
					AND COALESCE(INV_WO_GR_FLAG, 'N') = 'Y'
				WHERE T.IS_PROCESS = 0
					AND T.REGION = 'ICS_MAT_NO'
					AND ISNULL(T.REMARKS, '') = ''
				GROUP BY R.MAT_DOC_NO
					,R.ITEM_NO
					,R.COMP_PRICE_CD
				HAVING COUNT(1) > 1
				) TT ON T.SUPP_MANIFEST = TT.INV_REF_NO
				AND T.MAT_NO = TT.ICS_MAT_NO
				AND T.COMP_PRICE_CD = TT.COMP_PRICE_CD
				AND T.ROW_NO = TT.ROW_NO
			WHERE T.IS_PROCESS = 0
				AND T.REGION = 'ICS_MAT_NO'
				AND ISNULL(T.REMARKS, '') = ''

			UPDATE T
			SET T.REMARKS = 'B_EXIST'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			JOIN #TEMP_R_GRIR_BY_MAT_NO_ICS R ON R.INV_REF_NO = T.SUPP_MANIFEST
				AND R.ICS_MAT_NO = T.MAT_NO
				AND R.PART_COLOR_SFX = T.PART_COLOR_SFX
				AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
				AND ISNULL(R.CANCEL_FLAG, '0') = '0'
				AND COALESCE(INV_WO_GR_FLAG, 'N') = 'Y'
			WHERE T.REGION = 'ICS_MAT_NO'
				AND T.IS_PROCESS = 0
				AND ISNULL(T.REMARKS, '') = ''

			-- 2.2.C check based on ICS material number, packing type and reference document
			-- @L_N_COUNT_GR_C > 1
			UPDATE T
			SET T.REMARKS = 'Incorrect (Packing Type is not valid)'
				,T.IS_PROCESS = 1
				,T.VALIDATION_TYPE = 'E'
				,T.LOC = 'Check Remark'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			JOIN (
				SELECT R.INV_REF_NO
					,R.ICS_MAT_NO
					,R.COMP_PRICE_CD
					,T.ROW_NO
				FROM #TEMP_INV_UPLOAD_VALIDASI T
				JOIN #TEMP_R_GRIR_BY_MAT_NO_ICS R ON R.INV_REF_NO = T.SUPP_MANIFEST
					AND R.ICS_MAT_NO = T.MAT_NO
					AND R.PACKING_TYPE = T.PACKING_TYPE
					AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
					AND ISNULL(R.CANCEL_FLAG, '0') = '0'
					AND COALESCE(INV_WO_GR_FLAG, 'N') = 'Y'
				WHERE T.IS_PROCESS = 0
					AND T.REGION = 'ICS_MAT_NO'
					AND ISNULL(T.REMARKS, '') = ''
				GROUP BY R.MAT_DOC_NO
					,R.ITEM_NO
					,R.COMP_PRICE_CD
				HAVING COUNT(1) > 1
				) TT ON T.SUPP_MANIFEST = TT.INV_REF_NO
				AND T.MAT_NO = TT.ICS_MAT_NO
				AND T.COMP_PRICE_CD = TT.COMP_PRICE_CD
				AND T.ROW_NO = TT.ROW_NO
			WHERE T.IS_PROCESS = 0
				AND T.REGION = 'ICS_MAT_NO'
				AND ISNULL(T.REMARKS, '') = ''

			UPDATE T
			SET T.REMARKS = 'C_EXIST'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			JOIN #TEMP_R_GRIR_BY_MAT_NO_ICS R ON R.INV_REF_NO = T.SUPP_MANIFEST
				AND R.ICS_MAT_NO = T.MAT_NO
				AND R.PACKING_TYPE = T.PACKING_TYPE
				AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
				AND ISNULL(R.CANCEL_FLAG, '0') = '0'
				AND COALESCE(INV_WO_GR_FLAG, 'N') = 'Y'
			WHERE T.REGION = 'ICS_MAT_NO'
				AND T.IS_PROCESS = 0
				AND ISNULL(T.REMARKS, '') = ''

			-- 2.2.D check based on ICS material number and reference document
			-- @L_N_COUNT_GR_D > 1
			UPDATE T
			SET T.REMARKS = 'Incorrect (part no and manifest no is not valid)'
				,T.IS_PROCESS = 1
				,T.VALIDATION_TYPE = 'E'
				,T.LOC = 'Check Remark'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			JOIN (
				SELECT R.INV_REF_NO
					,R.ICS_MAT_NO
					,R.COMP_PRICE_CD
					,T.ROW_NO
				FROM #TEMP_INV_UPLOAD_VALIDASI T
				JOIN #TEMP_R_GRIR_BY_MAT_NO_ICS R ON R.INV_REF_NO = T.SUPP_MANIFEST
					AND R.ICS_MAT_NO = T.MAT_NO
					AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
					AND ISNULL(R.CANCEL_FLAG, '0') = '0'
					AND COALESCE(INV_WO_GR_FLAG, 'N') = 'Y'
				WHERE T.IS_PROCESS = 0
					AND T.REGION = 'ICS_MAT_NO'
					AND ISNULL(T.REMARKS, '') = ''
				GROUP BY R.MAT_DOC_NO
					,R.ITEM_NO
					,R.COMP_PRICE_CD
				HAVING COUNT(1) > 1
				) TT ON T.SUPP_MANIFEST = TT.INV_REF_NO
				AND T.MAT_NO = TT.ICS_MAT_NO
				AND T.COMP_PRICE_CD = TT.COMP_PRICE_CD
				AND T.ROW_NO = TT.ROW_NO
			WHERE T.IS_PROCESS = 0
				AND T.REGION = 'ICS_MAT_NO'
				AND ISNULL(T.REMARKS, '') = ''

			UPDATE T
			SET T.REMARKS = 'D_EXIST'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			JOIN #TEMP_R_GRIR_BY_MAT_NO_ICS R ON R.INV_REF_NO = T.SUPP_MANIFEST
				AND R.ICS_MAT_NO = T.MAT_NO
				AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
				AND ISNULL(R.CANCEL_FLAG, '0') = '0'
				AND COALESCE(INV_WO_GR_FLAG, 'N') = 'Y'
			WHERE T.REGION = 'ICS_MAT_NO'
				AND T.IS_PROCESS = 0
				AND ISNULL(T.REMARKS, '') = ''

			UPDATE T
			SET T.REMARKS = 'Incorrect (Part no and manifest no is not found)'
				,T.IS_PROCESS = 1
				,T.VALIDATION_TYPE = 'E'
				,T.LOC = 'Check Remark'
			FROM #TEMP_INV_UPLOAD_VALIDASI T
			LEFT JOIN #TEMP_R_GRIR_BY_MAT_NO_ICS R ON R.INV_REF_NO = T.SUPP_MANIFEST
				AND R.ICS_MAT_NO = T.MAT_NO
				AND R.COMP_PRICE_CD = T.COMP_PRICE_CD
				AND ISNULL(R.CANCEL_FLAG, '0') = '0'
				AND COALESCE(INV_WO_GR_FLAG, 'N') = 'Y'
			WHERE T.REGION = 'ICS_MAT_NO'
				AND T.IS_PROCESS = 0
				AND ISNULL(T.REMARKS, '') = ''
				AND ISNULL(R.INV_REF_NO, '') = ''

			/* call function invoice verification */
			EXEC SP_INVOICE_CREATION_VERIFICATION @USER_ID
				,@RI_V_PROCESSID
				,@RI_V_SUPP_CD
				,'ICS_MAT_NO'
				,@RESULT_2 OUTPUT;
				/* end function invoice verification */
		END

		SET @RESULT = CASE 
				WHEN @IsError = 'Y'
					THEN @IsError
				WHEN @RESULT_2 = 'Y'
					THEN @RESULT_2
				ELSE @IsError
				END;
	END TRY

	BEGIN CATCH
		SET @RESULT = 'Y';
		SET @PARAM1 = CONVERT(VARCHAR(1000), ERROR_MESSAGE());

		EXEC dbo.CommonGetMessage 'MPCS00999ERR'
			,@MSG_TXT OUTPUT
			,@N_ERR OUTPUT
			,@PARAM1

		INSERT INTO TB_R_LOG_D (
			PROCESS_ID
			,SEQUENCE_NUMBER
			,MESSAGE_ID
			,MESSAGE_TYPE
			,[MESSAGE]
			,LOCATION
			,CREATED_BY
			,CREATED_DATE
			)
		SELECT @RI_V_PROCESSID
			,(
				SELECT MAX(ISNULL(SEQUENCE_NUMBER, 0)) + 1
				FROM dbo.TB_R_LOG_D WITH (NOLOCK)
				WHERE PROCESS_ID = @RI_V_PROCESSID
				)
			,'MPCS00999ERR'
			,'ERR'
			,'MPCS00999ERR : ' + @MSG_TXT
			,@LOG_LOCATION
			,@USER_ID
			,GETDATE()
	END CATCH
END
